//PP19 Drill
// 1. Define template<typename T> struct S { T val; };.
// 2. Add a constructor, so that you can initialize with a T.
// 3. Define variables of types S<int>, S<char>, S<double>, S<string>, and S<vector<int>>;
// initialize them with values of your choice.

#include <iostream>
#include <map>
#include <string>
#include <vector>
using std::cout;
using std::pair;
using std::string;
using std::vector;

template<class T>
struct S {				      // Drill 1
public:
	S() : value(T()) { }
	S(T d) : value(d) { }     // Drill 2
private:
	T value;
};

int main() {
	S<char> s0(42);
	S<pair<string, double>> s1();
	S<int> s2(42);
	S<double> s3(1234.56e-78);
	S<string> s4("catdog");
	S<vector<int>> s5({ 1,2,3,4,5 });
}
