//PP19 Drill
// 1. Define template<typename T> struct S { T val; };.
// 2. Add a constructor, so that you can initialize with a T.
// 3. Define variables of types S<int>, S<char>, S<double>, S<string>, and S<vector<int>>;
// initialize them with values of your choice.
// 4. Read those values and print them.
// 5. Add a function template get() that returns a reference to val.

#include <iostream>
#include <map>
#include <string>
#include <vector>
using std::cout;
using std::pair;
using std::string;
using std::vector;

template<class T>
struct S {				      // Drill 1
public:
	S() : value(T()) { }
	S(T d) : value(d) { }     // Drill 2
	T getValue() { return value; }
	T& get();				  // Drill 5
private:
	T value;
};

template<class T>
T& S<T>::get() { return value; }

int main() {
	S<char> s0(42);
	S<pair<string, double>> s1();
	S<int> s2(42);
	S<double> s3(1234.56e-78);
	S<string> s4("catdog");
	S<vector<int>> s5({ 1,2,3,4,5 });
	cout << "s0.getValue() = " << s0.getValue() << '\n';
	//cout << "s1.getValue() = " << s1.getValue() << '\n'; //default value?
	cout << "s2.getValue() = " << s2.getValue() << '\n';
	cout << "s3.getValue() = " << s3.getValue() << '\n';
	cout << "s4.getValue() = " << s4.getValue() << '\n';
	cout << "s5.getValue()[0] = " << s5.getValue()[0] << '\n';
	cout << "s5.get()[1] = " << s5.get()[1] << '\n';
}
